/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "TrackInputBuffer.h"
#include <algorithm>
#include <cassert>

TrackInputBuffer::TrackInputBuffer()
:	inputs(),
	current(0)
{
}

Uint32& TrackInputBuffer::next()
{
	std::size_t prev = current;
	current = (current + 1) % SIZE;
	inputs[current] = inputs[prev];
	return inputs[current];
}

Uint32& TrackInputBuffer::operator[](std::size_t i)
{
	assert(i < SIZE);
	return inputs[(SIZE + current - i) % SIZE];
}

